#!/usr/bin/python2.7
#-*- coding: utf-8 -*-
from __future__ import print_function

#CFG Lib for students, nov 2016
#MIF08

import sys
sys.path.insert(0, 'lib')
from InstLC3 import *
from LibGraphes import *


import networkx as nx
import graphviz as gz
import copy
import itertools


debug=False

def RepresentsImm(s):
        try: 
                int(s)
                return True
        except ValueError:
                try:
                        int(s[1:]) #for sharp+num
                        return True
                except ValueError:
                        return False

#returns true iff t1 and t2 interfere
#t1,t2 temps, mapout=LV_out map, defined = map of kill sets.
def interfere(t1,t2,mapout,defined):
        #TODO
        return True
                
#CLASS FOR A BLOCK (1 statement per block)
                
class Block:
	count = 0
	def __init__(self):
		self._i = Block.count
		self._in = []
		self._out = []
		self._ins = None
		self._left = None
		self._right = []
                Block.count += 1
                #for liveness dataflow analysis
                self._gen = set() #should be initialised somewhere
                self._kill = set()

                
	def append(self, child):
		self._out.append(child)
		child._in.append(self)
		return child

	def checkDep(self, visited):
		if self in visited:
			return False
		if self._in:
			for b in self._in:
				if b not in visited and b._i < self._i:
					return False
			return True
		else:
			return True
                
        #used for final code printing
	def printIns(self, stream, visited,alloc):
		if self.checkDep(visited):
			visited.add(self)
			if self._ins:
				self._ins.printIns(stream,alloc)
			if self._out:
				for child in self._out:
					child.printIns(stream, visited,alloc)
		else:
			pass

        #Prints the current block and its sons (dot)
	def printDot(self, graph, visited):
		if self.checkDep(visited):
			visited.add(self)
			if self._ins:
				if self._left:
					s1 = str(self._i)+'_'+self._ins.ins+' ('+self._left+' <- '+str(self._right)+')'
					graph.add_node(s1)
				else:
					s1 = str(self._i)+'_'+self._ins.ins+' (_ <- '+str(self._right)+')'
					graph.add_node(s1)
			else:
				s1 = "START"
				graph.add_node(s1)
			
			if self._out:
				for child in self._out:
					if child._left:
						s2 = str(child._i)+'_'+child._ins.ins+' ('+child._left+' <- '+str(child._right)+')'
					else:
						s2 = str(child._i)+'_'+child._ins.ins+' (_ <- '+str(child._right)+')'
					graph.add_edge(s1,s2)
					child.printDot(graph, visited)
		else:
			pass

        #propagate dataflow information and update LV_in and LV_out sets (mapin,mapout)
        #and make a recursive call to my sons.
        def do_dataflow_onestep(self, mapin, mapout,visited):
                if self.checkDep(visited):
			visited.add(self)
                        i=self._i
                        if debug:
                                print("Dataflow : visiting node number "+str(i))
                        #update my LV_out set
                        mapout[i]=set()  #new emptyset                
                        for child in self._out:
                                if debug:
                                        print("DF: seen a child, its id is "+str(child._i))
                                mapout[i]=mapout[i].union(mapin[child._i])
                        #update my LV_in set
                        mapin[i]=(mapout[i].difference(self._kill)).union(self._gen)
                        for child in self._out:
                                child.do_dataflow_onestep(mapin, mapout,visited)
                else:
                        pass

        #construct the map of blocks-> defs (=kill)
        def update_defmap(self,defmap,visited):
               if self.checkDep(visited):
                       visited.add(self)
                       i=self._i
                       defmap[i]=self._kill
                       for child in self._out:
                               child.update_defmap(defmap,visited)
               else:
                       pass

                
class BlockPROG(Block):
	pass

class BlockLABEL(Block):
	def __init__(self, s):
		Block.__init__(self)
		self._ins = Instru3A(s+':','','','')

class BlockADD(Block):
	def __init__(self, dr, sr1, sr2orimm7):
		Block.__init__(self)
		self._left = dr
		self._right = [sr1, sr2orimm7]
		self._ins = Instru3A("ADD",str(dr),str(sr1),str(sr2orimm7))
                self._kill.add(dr)
                self._gen.add(sr1)  #even if sr1 = dr!
                if not(RepresentsImm(sr2orimm7)):
                        self._gen.add(sr2orimm7)
                if debug:
                        print("Block "+str(self._i)) 
                        print("KILL:",self._kill)
                        print("GEN:",self._gen)
                
                        
class BlockAND(Block):
	def __init__(self, dr, sr1, sr2orimm7):
		Block.__init__(self)
		self._left = dr
		self._right = [sr1, sr2orimm7]
		self._ins = Instru3A("AND",str(dr),str(sr1),str(sr2orimm7))
                ##### TODO
                #self._kill.add(??)
                #self._gen.add(??)
                if debug:
                        print("KILL:",self._kill)
                        print("GEN:",self._gen)
                        
class BlockNOT(Block):
	def __init__(self, dr,sr1):
		Block.__init__(self)
		self._left = dr
		self._right = [sr1]
		self._ins = Instru3A("NOT",str(dr),str(sr1),'')
                ##### TODO
                #self._kill.add(??)
                #self._gen.add(??)
                if debug:
                        print("KILL:",self._kill)
                        print("GEN:",self._gen)
                        
class BlockBR(Block):
	def __init__(self,s,label):
		Block.__init__(self)
		self._ins = Instru3A("BR"+s,str(label),'','')
                #TODO ?
                if debug:
                        print("KILL:",self._kill)
                        print("GEN:",self._gen)

                
class BlockGOTO(Block):
	def __init__(self,label):
		Block.__init__(self)
		self._ins = Instru3A("BR",str(label),'','')

### CFG MAIN CLASS
                
class CFG:
	def __init__(self, start):
                self._nbtmp = 0
                self._alltemps=[]
                self._nblabel=0
		self._start = start
		self._end = start
                self._mapin = {}  #will be map block -> set of variables
                self._mapout = {}
                self._mapdef =  {} #block : defined = killed vars in the block
                self._igraph = None #interference graph
                
        #Label Management.
        
        def newlabelIf(self):
                self._nblabel = self._nblabel+1
                return ("l_if_true_"+str(self._nblabel),"l_if_false_"+str(self._nblabel),"l_if_end_"+str(self._nblabel))
    
        def newlabelWhile(self):
                self._nblabel = self._nblabel+1
                return ("l_while_begin_"+str(self._nblabel),"l_while_end_"+str(self._nblabel))

        def newlabelCond(self):
                self._nblabel = self._nblabel+1
                return ("l_cond_true_"+str(self._nblabel),"l_cond_false_"+str(self._nblabel),"l_cond_end_"+str(self._nblabel))
        

        #### end of label management.
        
        #Temporaries Management.
        #all temps are prefixed by temp_
        def newtmp(self):
                self._nbtmp = self._nbtmp+1
                newvar='temp_'+str(self._nbtmp)
                self._alltemps.append(newvar)
                if debug:
                        print(self._alltemps)
                return newvar

        def printTempList(self):
                print(self._alltemps)
        ##### end of temp management.
        
        #### chaining blocks
	def setEnd(self, block):
		self._end = block
		return block

	def append(self, block):
		self._end.append(block)
		self._end = block
		return block

        ####liveness analysis main function
        def doDataflow(self):
                if debug:
                        print("Dataflow Analysis")
                nb = Block.count
                countit=0
                #initialisation of all mapout,mapin sets, and def = kill 
                for i in range(0,nb+1):
                        self._mapin[i]=set()
                        self._mapout[i]=set()
                #remove from there for students.
                stable=False
                while not(stable):
                        if debug:
                                print("step number "+str(countit))
                        countit=countit+1
                        if debug:
                                print(self._mapin)
                                print(self._mapout)
                        saveoldout = copy.deepcopy(self._mapout)
                        saveoldin = copy.deepcopy(self._mapin)
                        self._start.do_dataflow_onestep(self._mapin,self._mapout,set())
                        stable=True
                        for i in range(0,nb+1):
                                if (self._mapout[i] > saveoldout[i] or self._mapin[i] > saveoldin[i]): #sets are growing.
                                        stable = False
                if debug:
                        print("finished in "+str(countit)+" iterations")
                        print(self._mapin)
                        print(self._mapout)
                return(self._mapin,self._mapout)

        #Interference Graph. The graph 
        def doInterfGraph(self):
                #this function updates mapdef : block -> killed var
                self._start.update_defmap(self._mapdef,set())
                if debug:
                        print("map kill")
                        print(self._mapdef)
                self._igraph=Graph()
                if debug:
                        self.printTempList()
                if not self._mapout and not self._mapin:
                        print("hum, dataflow sets need to be initialised")
                        exit(1)
                else:
                        #TODO : construct the interf graph with the help of the API "LibGraphes"
                        pass
                return(self._igraph)

        def doAllocation(self):
                #TODO
                pass

        #Print - asm + dot
        #print the 3address code / or allocated
	def printCode(self, filename, assignment=None):
		output = open(filename, 'w') if filename else sys.stdout
		print(';;Automatically generated code',file=output)
		self._start.printIns(output, set(), assignment)
		if output is not sys.stdout:
			output.close()

	def printDot(self, filename): #prints the CFG
		graph = nx.DiGraph()
		self._start.printDot(graph, set())
		graph.graph['graph'] = dict()
		graph.graph['graph']['overlap'] = 'false'
		nx.drawing.nx_agraph.write_dot(graph, filename)
		gz.render('dot', 'pdf', filename) 
		gz.view(filename+'.pdf')


        
