from MuLexer import MuLexer
from MuParser import MuParser
from MuVisitor import MuVisitor
from MyMuCodeGenVisitor import *

import networkx as nx
import graphviz as gz

from antlr4 import*
from sys import *
from os import *

from antlr4.tree.Trees import Trees


def main():
    inputname=argv[1]
    input_s=FileStream(inputname)
    lexer = MuLexer(input_s)
    stream = CommonTokenStream(lexer)
    parser = MuParser(stream)
    tree=parser.prog();     
    
    (hd,rest)=path.splitext(inputname)
    output_name=hd+".asm"
    output_name_dot=hd+".dot"
    print("Code will be generated in file "+output_name)
    
    #Codegen Visitor, first argument is debug mode
    visitor3 = MyMuCodeGenVisitor(False,output_name,output_name_dot,parser);
    #parser is there to provide basic PP for expressions.
    
    cfg=visitor3.visit(tree)
    #print the cfg. next line should be commented in your final project.
    cfg.printDot(output_name_dot)
    

    #do dataflow analysis (live ranges)
    #mapin,mapout=cfg.doDataflow()
    #print("Live in map:")
    #print(mapin)
    #print("Live out map:")
    #print(mapout)

    #now interference graph.

    #igraph=cfg.doInterfGraph()
    #coloring=cfg.doAllocation()

    #then print...
    
if __name__ == '__main__':
    main()

